<template>
	<div class="qra-widget">
		<div class="qra-widget__header">
			<a href="https://google.com" @click="openLink('https://google.com')" class="qra-widget__header__button qra-widget__header__button--profile"></a>
			<a href="https://google.com" @click="openLink('https://google.com')" class="qra-widget__header__button qra-widget__header__button--settings"></a>
			<span class="qra-widget__header__button qra-widget__header__button--drag"></span>
			<a href="https://google.com" @click="openLink('https://google.com')" class="qra-widget__header__button qra-widget__header__button--help"></a>
			<button @click="closePopup" href="#" class="qra-widget__header__button qra-widget__header__button--close"></button>
		</div>
		
		<div class="loader" v-if="is_loading"></div>
		
		<template v-else>
			<div class="qra-widget__score">
				Quality Score: <quality-score :score="1" />
			</div>

			<div class="qra-widget__cards">
				<qra-card v-for="card in cards" :key="card.id" :problem="card" />
			</div>
		</template>
	</div>
</template>

<script>
import QraCard from '../components/QraCard.vue'
import QualityScore from '../components/QualityScore.vue'
export default {
	name: 'App',
	components: {
		QualityScore,
		QraCard
	},
	data() {
		return {
			cards: [],
			is_loading: false
		}
	},

	methods: {
		openLink(url) {
			chrome.tabs.create({url: url});
		},

		closePopup() {
			window.close();
		},
		
		load() {
			setTimeout(() => {
				this.is_loading = false;
				this.cards = [
					{
						id: 1,
						type: 'score',
						title: 'Negative imperatives',
						extended: {
							title: 'Lorem ipsum',
							text: 'Restate requirements with negative imperatives as one or more requirements with (positive) imperatives. Specify what the system shall do, not what it shall not do then let qvscribe automatically re-analyze to see if it’s fixed.'
						}
					},
					{
						id: 2,
						type: 'score',
						title: 'Multiple CONTINUANCES',
						extended: {
							title: 'Lorem ipsum',
							text: 'Restate requirements with negative imperatives as one or more requirements with (positive) imperatives. Specify what the system shall do, not what it shall not do then let qvscribe automatically re-analyze to see if it’s fixed.'
						}
					},
					{
						id: 3,
						type: 'warnings',
						title: 'PASSIVE VOICE',
						extended: {
							title: 'Lorem ipsum',
							text: 'Restate requirements with negative imperatives as one or more requirements with (positive) imperatives. Specify what the system shall do, not what it shall not do then let qvscribe automatically re-analyze to see if it’s fixed.'
						}
					},
					{
						id: 4,
						type: 'consistency',
						title: 'UNIT FOUND',
						extended: {
							title: 'Lorem ipsum',
							text: 'Restate requirements with negative imperatives as one or more requirements with (positive) imperatives. Specify what the system shall do, not what it shall not do then let qvscribe automatically re-analyze to see if it’s fixed.'
						}
					},
					{
						id: 5,
						type: 'score',
						title: 'Negative imperatives',
						extended: {
							title: 'Lorem ipsum',
							text: 'Restate requirements with negative imperatives as one or more requirements with (positive) imperatives. Specify what the system shall do, not what it shall not do then let qvscribe automatically re-analyze to see if it’s fixed.'
						}
					},
					{
						id: 6,
						type: 'score',
						title: 'Multiple CONTINUANCES',
						extended: {
							title: 'Lorem ipsum',
							text: 'Restate requirements with negative imperatives as one or more requirements with (positive) imperatives. Specify what the system shall do, not what it shall not do then let qvscribe automatically re-analyze to see if it’s fixed.'
						}
					},
					{
						id: 7,
						type: 'score',
						title: 'Multiple CONTINUANCES',
						extended: {
							title: 'Lorem ipsum',
							text: 'Restate requirements with negative imperatives as one or more requirements with (positive) imperatives. Specify what the system shall do, not what it shall not do then let qvscribe automatically re-analyze to see if it’s fixed.'
						}
					},
					{
						id: 8,
						type: 'warnings',
						title: 'PASSIVE VOICE',
						extended: {
							title: 'Lorem ipsum',
							text: 'Restate requirements with negative imperatives as one or more requirements with (positive) imperatives. Specify what the system shall do, not what it shall not do then let qvscribe automatically re-analyze to see if it’s fixed.'
						}
					},
					{
						id: 9,
						type: 'consistency',
						title: 'UNIT FOUND',
						extended: {
							title: 'Lorem ipsum',
							text: 'Restate requirements with negative imperatives as one or more requirements with (positive) imperatives. Specify what the system shall do, not what it shall not do then let qvscribe automatically re-analyze to see if it’s fixed.'
						}
					},
				];
			}, 1);
		}
	},

	mounted() {
		this.load();
	}
}
</script>

<style lang="scss">
* {
	position: relative;
	padding: 0px;
	margin: 0px;
	box-sizing: border-box;
}
html {
	width: 430px;
	background-color: #ECECEC;
	padding: 20px;
	font-family: -apple-system,BlinkMacSystemFont,"Segoe UI",Roboto,Oxygen-Sans,Ubuntu,Cantarell,"Helvetica Neue",sans-serif;
}
body {
	font-size: 12px;
	color: #032D3A;
}

.qra-widget {
	&__header {
		display: flex;
		flex-direction: row;
		justify-content: space-between;
		align-items: flex-start;
		&__button {
			width: 22px;
			height: 22px;
			display: block;
			background-color: transparent;
			box-shadow: none;
			border: none;
			outline: none;
			background-size: auto 22px;
			background-repeat: no-repeat;
			cursor: pointer;
			background-image: url('../assets/icons.png');
			&:hover {
				opacity: .7;
			}
			&--profile {
				margin-right: 10px;
				background-position: 0 0;
			}
			&--settings {
				background-position: -22px 0;
			}
			&--drag {
				margin: 0 auto;
				background-position: -44px 0;
				cursor: move;
			}
			&--help {
				background-position: -66px 0;
			}
			&--close {
				margin-left: 10px;
				background-position: -88px 0;
			}
		}
	}

	&__score {
		margin: 40px 0px 30px;
		.quality-score {
			display: inline-block;
			vertical-align: middle;
			top: -1px;
			margin-left: 2px;
		}
	}
}
</style>
